import React, { useState, useEffect } from "react";
import { IconMenuAction } from "./IconMenuAction";
import { useClickOutside } from "./useClickOutside";
var Dropdown = function (_a) {
    var iconActionMenu = _a.iconActionMenu, embeddedIconMenuActionStyle = _a.embeddedIconMenuActionStyle, h_item = _a.h_item, preKey = _a.preKey, item = _a.item, popupDirection = _a.popupDirection;
    var _b = useState(false), isOpen = _b[0], setIsOpen = _b[1];
    var _c = useClickOutside(), ref = _c[0], hasClickedOutside = _c[1];
    useEffect(function () {
        if (hasClickedOutside) {
            setIsOpen(false);
        }
    }, [hasClickedOutside]);
    var toggleOpen = function () { return setIsOpen(!isOpen); };
    var menuClass = "dropdown-menu" + (isOpen ? " show" : "");
    return (React.createElement("div", { className: "dropdown " + (popupDirection === "left" ? "dropleft" : "rightdrop"), onClick: toggleOpen, ref: ref },
        React.createElement("button", { className: "btn btn-secondary dropdown-toggle", type: "button", id: "dropdownMenuButton", "data-toggle": "dropdown", "aria-haspopup": "true", style: {
                backgroundColor: "transparent",
                border: "0px",
                boxShadow: "none",
            } },
            React.createElement(IconMenuAction, { icon: iconActionMenu, embeddedIconStyle: embeddedIconMenuActionStyle })),
        React.createElement("div", { className: menuClass, "aria-labelledby": "dropdownMenuButton" }, h_item.actionItems.map(function (menu, mi) {
            if (menu.divider) {
                return React.createElement("div", { class: "dropdown-divider", key: preKey + "m" + mi });
            }
            if (!menu.isVisible) {
                return (React.createElement("button", { class: "dropdown-item", type: "button", key: preKey + "m" + mi, onClick: function () { return menu.onClick(item); } }, menu.labelFormat ? menu.labelFormat(item) : menu.label));
            }
            else {
                if (menu.isVisible && menu.isVisible(item)) {
                    return (React.createElement("button", { class: "dropdown-item", type: "button", key: preKey + "m" + mi, onClick: function () { return menu.onClick(item); } }, menu.labelFormat ? menu.labelFormat(item) : menu.label));
                }
                else {
                }
            }
        }))));
};
export default Dropdown;
