import { useState, useRef, useEffect } from "react";
export function useClickOutside() {
    var ref = useRef();
    var _a = useState({
        hasClickedOutside: false,
    }), state = _a[0], setState = _a[1];
    function handleEvent(e) {
        /* istanbul ignore else  */
        if (ref && ref.current) {
            if (ref.current.contains(e.target)) {
                setState({ hasClickedOutside: false });
            }
            else {
                setState({ hasClickedOutside: true });
            }
        }
    }
    useEffect(function () {
        if (window.PointerEvent) {
            document.addEventListener("pointerdown", handleEvent);
        }
        else {
            document.addEventListener("mousedown", handleEvent);
            document.addEventListener("touchstart", handleEvent);
        }
        return function () {
            if (window.PointerEvent) {
                document.removeEventListener("pointerdown", handleEvent);
            }
            else {
                document.removeEventListener("mousedown", handleEvent);
                document.removeEventListener("touchstart", handleEvent);
            }
        };
    }, []);
    return [ref, state.hasClickedOutside];
}
